# File: Podcast.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.Tabajara.BaseTabajara import BaseTabajara
from RegionTabajara import RegionTabajara


from Products.TabajaraPodcasting.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    TextField('description',
        widget=TextAreaWidget(
            label='Description',
            label_msgid='TabajaraPodcasting_label_description',
            description_msgid='TabajaraPodcasting_help_description',
            i18n_domain='TabajaraPodcasting',
        ),
        required=1,
        accessor="Description",
        searchable=1
    ),

    TextField('body',
        allowable_content_types=('text/html',),
        widget=RichWidget(
            label='Body',
            label_msgid='TabajaraPodcasting_label_body',
            description_msgid='TabajaraPodcasting_help_body',
            i18n_domain='TabajaraPodcasting',
        ),
        default_output_type='text/html'
    ),

    FileField('sound',
        widget=FileWidget(
            label="Sound File",
            label_msgid='TabajaraPodcasting_label_sound',
            description_msgid='TabajaraPodcasting_help_sound',
            i18n_domain='TabajaraPodcasting',
        ),
        storage=AttributeStorage(),
        primary=1
    ),

    StringField('soundURL',
        widget=StringWidget(
            label="Sound URL",
            description="If you are posting an external podcast you you can inform the external URL here without upload the whole sound file.",
            label_msgid='TabajaraPodcasting_label_soundURL',
            description_msgid='TabajaraPodcasting_help_soundURL',
            i18n_domain='TabajaraPodcasting',
        )
    ),

    ImageField('thumbnail',
        widget=ImageWidget(
            label='Thumbnail',
            label_msgid='TabajaraPodcasting_label_thumbnail',
            description_msgid='TabajaraPodcasting_help_thumbnail',
            i18n_domain='TabajaraPodcasting',
        ),
        storage=AttributeStorage(),
        sizes={'mini':(64,64),'normal':(140,140)}
    ),

    StringField('external_url',
        widget=StringWidget(
            label="External URL",
            label_msgid='TabajaraPodcasting_label_external_url',
            description_msgid='TabajaraPodcasting_help_external_url',
            i18n_domain='TabajaraPodcasting',
        )
    ),

    IntegerField('creative_commons',
        widget=IntegerWidget(
            label="Creative Commons Id",
            label_msgid='TabajaraPodcasting_label_creative_commons',
            description_msgid='TabajaraPodcasting_help_creative_commons',
            i18n_domain='TabajaraPodcasting',
        )
    ),

),
marshall=PrimaryFieldMarshaller()
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Podcast_schema = BaseSchema + \
    getattr(BaseTabajara,'schema',Schema(())) + \
    getattr(RegionTabajara,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Podcast(BaseTabajara,RegionTabajara,BaseContent):
    """
    <p></p>
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseTabajara,'__implements__',()),) + (getattr(RegionTabajara,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'Podcast'

    meta_type                  = 'Podcast'
    portal_type                = 'Podcast'
    allowed_content_types      = [] + list(getattr(BaseTabajara, 'allowed_content_types', [])) + list(getattr(RegionTabajara, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 1
    #content_icon               = 'Podcast.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "Podcast"
    typeDescMsgId              = 'description_edit_podcast'

    actions =  (


       {'action':      "string:$object_url/podcast_view",
        'category':    "object",
        'id':          'view',
        'name':        'podcast_view',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


    )

    schema = Podcast_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declareProtected('View', 'index_html')
    def index_html(self, REQUEST=None, RESPONSE=None):
        """ Download the Podcast
        """
	field = self.getPrimaryField()
        return field.download(self)



registerType(Podcast,PROJECTNAME)
# end of class Podcast

##code-section module-footer #fill in your manual code here
##/code-section module-footer



